import { jsx as _jsx } from "@emotion/react/jsx-runtime";
/** @jsxImportSource @emotion/react */
import React from 'react';
// import * as React from "react";
// import toaster, { Position } from "react-toastnotes";
import { Alert } from "./Alert";
import { useTheme, ThemeProvider } from "./Theme/Providers";
import { toast } from 'react-toastify';
import 'react-toastify/dist/ReactToastify.css';
/** 类Hook的 需要用到jsx, css的场合,不同一般地Hook。
 * We export toast as a hook because it allows us to consume
 * the current theme context that it's in and pass that
 * onto our render function
 报错来源： ReactDOM.render is no longer supported in React 18. Use createRoot instead. Until you switch to the new API, your app will behave as if it's running React 17.
 */
export function useToast() {
    const theme = useTheme();
    function notify({ position = 'bottom-center', duration, render, title, subtitle, intent }) {
        const options = {
            position,
            duration
        };
        /*  export declare type ToastContent<T = unknown> = React.ReactNode | ((props: ToastContentProps<T>) => React.ReactNode);
         interface ToastOptions<Data = {}> extends CommonOptions
              (,type?: export declare type TypeOptions = 'info' | 'success' | 'warning' | 'error' | 'default';
    
          export interface ToastContentProps<Data = {}> {
          closeToast?: () => void;
          toastProps: ToastProps;
          data?: Data;
        }
        export interface ToastProps extends ToastOptions {
            isIn: boolean;
            staleId?: Id;
            toastId: Id;
            key: Id;
            transition: ToastTransition;
            closeToast: () => void;
            position: ToastPosition;
            children?: ToastContent;
            draggablePercent: number;
            draggableDirection?: DraggableDirection;
            progressClassName?: ToastClassName;
            className?: ToastClassName;
            bodyClassName?: ToastClassName;
            deleteToast: () => void;
            theme: Theme;
            type: TypeOptions;
            iconOut?: React.ReactNode;
        }
        纯字符创也算是: React.ReactNode;
    
    
        * */
        // const  oprss={ closeToast: onClose, toastProps:{toastId:id } } as ToastContentProps<{}>;
        //俩条路都是 （return React.ReactNode）
        if (render) {
            return toast(({ closeToast: onClose, toastProps: { toastId: id } }) => (_jsx(React.Fragment, { children: _jsx(ThemeProvider, { theme: theme, children: render({ onClose, id }) }) })), options);
        }
        //普通的 export type MessageProp = React.ReactNode | ((callback: MessageCallback) => React.ReactNode) | string;
        toast(({ closeToast: onClose, toastProps: { toastId: id } }) => (_jsx(React.Fragment, { children: _jsx(ThemeProvider, { theme: theme, children: _jsx(Alert, { id: String(id), title: title, component: "div", elevation: "md", subtitle: subtitle, intent: intent, onRequestClose: onClose }) }) })), options);
    }
    return notify;
}
//# sourceMappingURL=Toast.js.map